#!/usr/bin/perl
use strict;
use warnings;

use Test::More;
use Fennec::Lite;
use Test::Exception;

our $CLASS;

BEGIN {
    $CLASS = 'Mock::Quick::Method';
    use_ok( $CLASS );
}

tests create => sub {
    my $code = sub { 1 };
    my $obj = $CLASS->new( $code );
    isa_ok( $obj, $CLASS );
};

tests error => sub {
    throws_ok { $CLASS->new( "foo" ) }
        qr/Constructor to $CLASS takes a single codeblock/,
        "Must be created with codeblock"
};

run_tests;
done_testing;
